;###################################
;#          FMOD Player            #
;# You need fmod.dll for this Code #
;#  (c) 2002, Sebastian Schulz     #
;#  Email: sebastian@sebatec.biz   #
;###################################

#Main_Window = 0
#Main_Window_Flags = #PB_Window_ScreenCentered | #PB_Window_SystemMenu | #PB_Window_MinimizeGadget


;-Gadget Konstante
#Trackbar_MainWindow    = 0
#PlayerPanel_MainWindow = 1


;-PlayerToolbar Konstante
#Load_Player_MainWindow    = 2
#Stop_Player_MainWindow    = 3
#Play_Player_MainWindow    = 4
#Pause_Player_MainWindow   = 5
#Next_Player_MainWindow    = 6
#Loop_Player_MainWindow    = 7

IncludeFile "inc\con_struc.pbi"
IncludeFile "inc\fmod_proc.pbi"

Structure open_file
    FileName.s
    PlayerPointer.l
EndStructure

Global File.open_file, hToolbarWnd
originalbuffer.l : newbuffer.l : length.l : param.l : Callback_return.l 
stream.l : buff.l : len.l : param.l
DrawH.f : DrawX.f : DrawC.f : spectrum.f

Procedure.l PlayerCallback(hWnd,Msg,wParam,lParam)
Select Msg
Case #WM_CLOSE
PostQuitMessage_(0)

Case #WM_COMMAND
    Select lParam
    
    Case TBiD()
        Select wParam
        Case #Load_Player_MainWindow
            FileName.s = OpenFileRequester("Open File ...", "", "Supported Files | *.raw;*.wav;*.mp2;*.mp3;*.ogg;*.wma;*.asf", 0)
              If Len(FileName)
                SetGadgetState(#Loop_Player_MainWindow, 0)
                Delay(10)
                FSOUND_Stream_Stop(File\PlayerPointer)
                FSOUND_Stream_Close(File\PlayerPointer)
                
                File\FileName = FileName
                File\PlayerPointer = FSOUND_Stream_OpenFile(@File\FileName, #FSOUND_NORMAL, 0)
                FSOUND_Stream_SetEndCallback(File\PlayerPointer, ?EndCallback, 0)
                StatusBarText(0, 0, "Loaded "+GetFilePart(File\FileName), 0)
              EndIf 
    
        
        Case #Stop_Player_MainWindow
            FSOUND_Stream_Stop(File\PlayerPointer)
            StatusBarText(0, 0, "Ready", 0)
            
        Case #Play_Player_MainWindow
            FSOUND_Stream_Play(0,File\PlayerPointer)
            StatusBarText(0, 0, "Is playing "+GetFilePart(File\FileName), 0)
    
        Case #Pause_Player_MainWindow
        If FSOUND_GetPaused(0)
          FSOUND_SetPaused(0, #false)
          StatusBarText(0, 0, "Is playing "+GetFilePart(File\FileName), 0)
        Else
          FSOUND_SetPaused(0, #true)
          StatusBarText(0, 0, "Pause", 0)
        EndIf
  
        
        Case #Next_Player_MainWindow
        EndSelect
        
    EndSelect
EndSelect
ProcedureReturn DefWindowProc_(hWnd,Msg,wParam,lParam)
EndProcedure


Procedure CreatePlayerGadget(Parent.l, x.l, y.l)
ClassName.s = "Player"
WindowClass.WNDCLASSEX
WindowClass\cbSize = SizeOf(WNDCLASSEX)
WindowClass\style = 0 
WindowClass\lpfnWndProc = @PlayerCallback()
WindowClass\cbClsExtra = 0
WindowClass\cbWndExtra = 0
WindowClass\hInstance = GetModuleHandle_(0)
WindowClass\hIcon = 0
WindowClass\hCursor = LoadCursor_(#NULL,#IDC_ARROW)
WindowClass\hbrBackground = #COLOR_WINDOW
WindowClass\lpszMenuName = 0
WindowClass\lpszClassName = @ClassName
WindowClass\hIconSm = 0

If RegisterClassEx_(@WindowClass)=#false
    MessageRequester("Error","Failed to open window",0)
    End
EndIf

hToolbarWnd=CreateWindowEx_(#WS_EX_TOOLWINDOW,"Player",0,#WS_CHILD|#WS_VISIBLE|#WS_CLIPCHILDREN|#WS_CLIPSIBLINGS,30,30,117,83, Parent,0,GetModuleHandle_(0),0)

Image1 = CatchImage(1, ?PlayerImage)
Image2 = CatchImage(2, ?PlayerImageMA)
SetWindowPos_(hToolbarWnd,#HWND_TOP,x,y,156,41, 0 )

    CreateTB(0, hToolbarWnd, 32, 32)
    SetTBimage(Image1,Image2,#TBpro_NORMAL)
    
    AddTBbutton(#Load_Player_MainWindow, 1, #TBpro_Button)
    AddTBbutton(#Stop_Player_MainWindow, 2, #TBpro_Button)
    AddTBbutton(#Play_Player_MainWindow, 3, #TBpro_Button)
    AddTBbutton(#Pause_Player_MainWindow,4, #TBpro_Button)

EndProcedure


InitSprite()
LoadFMOD()
FSOUND_Init(44100, 20,0)

hWnd = OpenWindow(#Main_Window, 0, 0, 400, 200, #Main_Window_Flags, "FMOD Player")
    OpenWindowedScreen(hWnd, 10, 5, 200, 100, 0, 0, 0)

CreateGadgetList(hWnd)
hLoop = CheckBoxGadget(#Loop_Player_MainWindow, 170, MenuHeight()+122, 80,32, "Repeat")
CreatePlayerGadget(hWnd, 10, MenuHeight()+120)
TrackBarGadget(#Trackbar_MainWindow, 10, MenuHeight()+95, 380, 20, 0, 100)
Frame3DGadget(#PlayerPanel_MainWindow, 215, 0, 175, 104, "" , 0)

CreateStatusBar(0, hWnd)
    AddStatusBarField(400)  ;For Text
    StatusBarText(0, 0, "Ready", 0)
    
FSOUND_DSP_Create(?FSOUND_DSPCALLBACK, #FSOUND_DSP_DEFAULTPRIORITY_USER, 0)
FSOUND_DSP_SetActive(FSOUND_DSP_GetFFTUnit(),#true)


Repeat
If IsScreenActive()
FlipBuffers()
ClearScreen(0, 0, 81)
    *DSP_Spectrum = FSOUND_DSP_GetSpectrum()
    StartDrawing(ScreenOutput())
    For count=0 To 250 ;To 511
        spectrum.f = PeekF(*DSP_Spectrum+(count*4))*100
            Box(DrawX, 100, 2,-DrawH, DrawC)
            DrawH=spectrum
            DrawX=count*4
            DrawC=spectrum
            If DrawC < 80   ;Play with Color
            DrawC = RGB(0, $DD,0)
            Else
            DrawC = RGB(255*DrawC, 0,0)
            EndIf
    Next
    StopDrawing()
EndIf

If FSOUND_Stream_GetLength(File\PlayerPointer)
SetGadgetState(#Trackbar_MainWindow, FSOUND_Stream_GetPosition(File\PlayerPointer)*100/FSOUND_Stream_GetLength(File\PlayerPointer))
EndIf

WindowEvent = WindowEvent()
If WindowEvent
    Select WindowEvent
    ;-Programm Ende
    Case #PB_EventCloseWindow
        SetGadgetState(#Loop_Player_MainWindow, 0)
        Delay(10)
        FSOUND_Stream_Stop(File\PlayerPointer)
        FSOUND_Stream_Close(File\PlayerPointer)
        FSOUND_Close()
        CloseFMOD()
        End

    ;-Gadget Events
    Case #PB_EventGadget
        Select EventGadgetID()
        Case #Trackbar_MainWindow
        FSOUND_Stream_SetPosition(File\PlayerPointer,GetGadgetState(#Trackbar_MainWindow)*FSOUND_Stream_GetLength(File\PlayerPointer)/100)

        EndSelect    

    EndSelect
Else
    Delay(10)
EndIf

ForEver

; Special Thanks to Danilo's ASM Help
FSOUND_DSPCALLBACK: 
  !MOV  dword EAX,[esp+4]
  !MOV  dword [v_originalbuffer], EAX
  !MOV  dword EAX,[esp+8]
  !MOV  dword [v_newbuffer], EAX 
  !MOV  dword EAX,[esp+12]
  !MOV  dword [v_length], EAX
  !MOV  dword EAX,[esp+16]
  !MOV  dword [v_param], EAX

  !PUSH dword EBX
  !PUSH dword ECX 
  !PUSH dword EBP 
  !PUSH dword ESI 
  !PUSH dword EDI 
  !MOV dword [v_Callback_return],0 
; BEGIN BASIC CODE 

;Not Needed
; END BASIC CODE 
  !POP dword EDI 
  !POP dword ESI 
  !POP dword EBP 
  !POP dword ECX 
  !POP dword EBX 
  !MOV dword EAX,[v_Callback_return] 
  !RET 
; END CALLBACK PROCEDURE 

EndCallback: 
  !MOV  dword EAX,[esp+4]
  !MOV  dword [v_stream], EAX
  !MOV  dword EAX,[esp+8]
  !MOV  dword [v_buff], EAX
  !MOV  dword EAX,[esp+12]
  !MOV  dword [v_len], EAX
  !MOV  dword EAX,[esp+16]
  !MOV  dword [v_param], EAX

  !PUSH dword EBX
  !PUSH dword ECX 
  !PUSH dword EBP 
  !PUSH dword ESI 
  !PUSH dword EDI 
  !MOV dword [v_Callback_return],0 
; BEGIN BASIC CODE 

  If GetGadgetState(#Loop_Player_MainWindow)
    StatusBarText(0, 0, "Repeat", 0)
    Delay(2000)
    FSOUND_Stream_Play(0,stream)
    StatusBarText(0, 0, "Is playing "+GetFilePart(File\FileName), 0)
  Else
    StatusBarText(0, 0, "Ready", 0)
  EndIf
; END BASIC CODE 
  !POP dword EDI 
  !POP dword ESI 
  !POP dword EBP 
  !POP dword ECX 
  !POP dword EBX 
  !MOV dword EAX,[v_Callback_return] 
  !RET 
; END CALLBACK PROCEDURE 

DataSection
PlayerImage:
IncludeBinary "Icons\Player.bmp"
PlayerImageMA:
IncludeBinary "Icons\PlayerMA.bmp"
EndDataSection 
; EOF